"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const base_1 = require("./base");
class ValidationError extends base_1.BaseError {
    constructor(code = ValidationError.DEFAULT, invalidField, invalidValue, message, type) {
        const details = { invalidField, invalidValue };
        if (message) {
            details.message = message;
        }
        if (type) {
            details.type = type;
        }
        super(Object.assign({}, ValidationError.defaultOptions, {
            code,
            details
        }));
        this.errorPrefix = 'ERROR_VALIDATION_';
        this.code = this.errorPrefix + code;
    }
}
ValidationError.DEFAULT = 'FAILED';
ValidationError.VALIDATION = 'VALIDATION';
ValidationError.NO_STRING = 'NO_STRING';
ValidationError.NO_INT = 'NO_INT';
ValidationError.NO_EMAIL = 'NO_EMAIL';
ValidationError.NO_ARRAY = 'NO_ARRAY';
ValidationError.INT_OUT_OF_BOUNDS = 'INT_OUT_OF_BOUNDS';
ValidationError.STRING_OUT_OF_BOUNDS = 'STRING_OUT_OF_BOUNDS';
ValidationError.defaultOptions = {
    code: ValidationError.VALIDATION,
    innerDetails: {},
    details: {},
    status: base_1.BaseError.CODE_BAD_REQUEST
};
exports.ValidationError = ValidationError;
