"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const item_validator_1 = require("../validation/item_validator");
class Controller {
    validate(ctx, cb) {
        let params;
        if (ctx.request.method === 'GET') {
            params = ctx.request.query;
        }
        else {
            const contentType = ctx.req.headers['content-type'];
            if (!contentType || contentType.indexOf('application/json') > -1) {
                params = ctx.request.body;
            }
            else if (contentType.indexOf('multipart/form-data') > -1 && ctx.request.body.fields) {
                params = ctx.request.body.fields;
            }
            else {
                params = ctx.request.body;
            }
        }
        return cb(this._validate(params));
    }
    _validate(item) {
        return new item_validator_1.ItemValidator(item);
    }
}
exports.Controller = Controller;
