"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const bodyParser = require("koa-body");
const log_middleware_1 = require("./log_middleware");
const error_middleware_1 = require("./error_middleware");
const jwt_middleware_1 = require("./jwt_middleware");
const _ = require("lodash");
const cors_middleware_1 = require("./cors_middleware");
const user_agent_middleware_1 = require("./user_agent_middleware");
const success_middleware_1 = require("./success_middleware");
function createDefaultMiddlewareCollection(config) {
    return {
        bodyParser: bodyParser({ multipart: true }),
        log: log_middleware_1.logMiddleware,
        error: error_middleware_1.errorMiddleware,
        jwt: jwt_middleware_1.createJwtMiddleware(_.get(config, 'jwt.secret'), _.get(config, 'jwt.publicPath'), _.get(config, 'jwt.Prefix')),
        cors: cors_middleware_1.createCorsMiddleware(_.get(this.config, 'cors.origin'), _.get(this.config, 'cors.credentials')),
        userAgent: user_agent_middleware_1.userAgentMiddleware,
        success: success_middleware_1.successMiddleware
    };
}
exports.createDefaultMiddlewareCollection = createDefaultMiddlewareCollection;
